import json
import os
import shutil

#读取歌曲文件

#beatsaber歌曲总路径
def beatSaberDirInputCheck():
    while 1:
        beatSaberBaseDir = input('请输入BeatSaber歌曲文件夹总路径，退出请按"q"：\n')
        if os.path.exists(beatSaberBaseDir):
            return beatSaberBaseDir
        elif beatSaberBaseDir == 'q':
            return beatSaberBaseDir
            break
        else:
            print('输入路径有误，请将"此电脑"中的路径完整复制，退出请按"q"!\n')
            continue

#beatsaber歌单列表
def beatSaberSongDir(beatSaberBaseDir):
    beatSaberSongDir = []
    #beatSaberBaseDir = beatSaberDirInputCheck() #获取BeatSaber歌曲文件夹总路径
    for i in os.listdir(beatSaberBaseDir):
        beatSaberSongDir.append(os.path.join(beatSaberBaseDir, i))
    return beatSaberSongDir

#将所有歌曲加入到歌曲列表songList[]中
def songList(beatSaberBaseDir):
    songList = []
    songCount = 0
    beatSaberSongDir_ = beatSaberSongDir(beatSaberBaseDir)
    for i in beatSaberSongDir_:
        for j in os.listdir(i):
            try:
                songCount += 1
                songList.append(j.split('(')[1].split('-')[0].strip())
            except:
                IndexError
    return songList


#找出beatsaber歌单和自己歌单中重复的歌曲
def mySong(beatSaberBaseDir):
    songList_ = songList(beatSaberBaseDir)
    with open('songList.txt', 'r') as f:
        listFull = json.load(f)
    set1 = set(listFull)
    set2 = set(songList_)
    iset = set1.intersection(set2) #取两个元组的并集
    return list(iset)

#移动目标路径检查
def moveDirInputCheck():
    while 1:
        mvDir = input('请输入保存歌曲的新路径，退出请按"q"!\n')
        if os.path.exists(mvDir):
            return mvDir
        elif mvDir == 'q':
            return mvDir
            break
        else:
            print('输入路径有误，请检查目录是否创建！退出请按"q"!\n')
            continue

#移动文件到新的目录

def moveFile(beatSaberSongDir,beatSaberBaseDir,mvDir):
    c = 0
    for i in beatSaberSongDir:
        for j in os.listdir(i):
            try:
                if j.split('(')[1].split('-')[0].strip() in mySong(beatSaberBaseDir):# 查看是否有重复歌曲
                    jName = j.split('(')[1].split('-')[0].strip()
                    c += 1  # 计数器，查看一共有多少个重合歌曲
                    currentPath = os.path.join(beatSaberBaseDir, i, j)
                    shutil.copytree(currentPath, os.path.join(mvDir, j))
                    print(f'检测到歌曲《{jName}》，正在迁移..\n')
            except:
                IndexError
                break
    print(f'一共移动了{c}首歌曲。\n')