import mutagen
import json
import os
#创建保存歌曲名的列表


#歌曲文件源路径
#提取mp3歌曲名函数
def mp3FileName(dirSrc,song):
    songFile = os.path.join(dirSrc,song) #定位到歌曲文件
    songInfo = mutagen.File(songFile)
    return (songInfo.tags["TIT2"][0]) #返回歌曲名


def flacFileName(dirSrc,song):
    songFile = os.path.join(dirSrc,song)
    songInfo = mutagen.File(songFile)
    return (songInfo.tags['TITLE'][0])

#提取mp3歌曲名

def extractMp3(dirSrc):
    mp3List = []
    countMp3 = 0
    for song in os.listdir(dirSrc):
        if song.split('.')[-1] == 'mp3':
            countMp3 += 1
            try:
                mp3List.append(mp3FileName(dirSrc,song))
            except:
                KeyError
    print(
        f'mp3歌曲文件总数为:{countMp3}\n'
        f'提取mp3歌曲名数目为:{len(mp3List)}\n'
    )
    return mp3List

#提取flac歌曲名

def extractFlac(dirSrc):
    flacList = []
    countFlac = 0
    for song in os.listdir(dirSrc):
        if song.split('.')[-1] == 'flac':
            countFlac += 1
            try:
                flacList.append(flacFileName(dirSrc,song))
            except:
                KeyError
    print(
        f'flac歌曲文件总数为:{countFlac}\n'
        f'提取mp3歌曲名数目为:{len(flacList)}\n'
    )
    return flacList

def dirInputCheck():
    while 1:
        dirSrc = input('请输入您自己的歌曲路径，请复制绝对路径，确保所有歌曲文件都在该路径下！退出请按"q"!\n')
        if os.path.exists(dirSrc):
            return dirSrc
        elif dirSrc == 'q':
            return dirSrc
            break
        else:
            print('输入路径有误，请将"此电脑"中的路径完整复制，退出请按"q"!\n')
            continue


def listMerge():
    dirSrc = dirInputCheck()
    if dirSrc == 'q':
        print('感谢使用！\n')
        exit()
    else:
        mp3List = extractMp3(dirSrc)
        flacList = extractFlac(dirSrc)
        listFull = mp3List + flacList
        with open('songList.txt', 'w') as f:
            json.dump(listFull, f)
        print('文件列表以json形式存储到程序路径。')




